#include <mega8.h>
#include <m8_128.h> 
#include <stdio.h>
#include <stdlib.h>
#include <delay.h>
//#include "NokiaLCD.c" 
//#include "NokiaLCD.h"
#define FOSC 14745600// Clock Speed
#define BAUD 57600
#define MYUBRR FOSC/16/BAUD-1
#define ADC_VREF_TYPE 0x00
#define discharge_on PORTC|=(1<<PC2);
#define discharge_off PORTC&=(0<<PC2);
#define charge_on PORTC|=(1<<PC1); // = 1;
#define charge_off PORTC&=(0<<PC1); //.1 = 0;

unsigned int ticks, i;
char *str_buf, fl_12, sreg;
unsigned char integer[6];
 
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
 //PORTD|=(1<<PD2);
 //PORTD&=(0<<PD2);
}

interrupt [TIM1_CAPT] void timer1_capt_isr(void)
{
 //PORTD|=(1<<PD3);
 //PORTD&=(0<<PD3);
} 

// Analog Comparator interrupt service routine
interrupt [ANA_COMP] void ana_comp_isr(void)
{
 //charge_off;
 fl_12=5;
 //PORTD|=(1<<PD4);
 //PORTD&=(0<<PD4);
}

unsigned int read_adc(unsigned char adc_input)
 {
  ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
  delay_us(10);
  ADCSRA|=0x40;
  while ((ADCSRA & 0x10)==0);
  ADCSRA|=0x10;
  return ADCW;
}

void USART_Init (unsigned int ubrr)
 {
  UBRRH=(unsigned char)(ubrr>>8);
  UBRRL=(unsigned char) ubrr;
  UCSRB=(1<<TXEN);
  UCSRC=(1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
 }


void init(void)
 {
  PORTC=0x00;
  DDRC=0x06;
  PORTD=0x00;
  DDRD=0;//x1C; //0x1C;
  TCCR1A=0x00;
  TCNT1H=0x00;
  TCNT1L=0x00;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x00;
  OCR1BH=0x00;
  OCR1BL=0x00;
  TIMSK=0;//x24; //0x20; //0x24;
  ACSR=0x4E;
  SFIOR=0x00;
  ADMUX=ADC_VREF_TYPE & 0xff;
  ADCSRA=0x87;
 }
 
void LcdInt (unsigned int num)
 {                   
  char pucha;

  pucha = 48+ num / 10000;
  num = num % 10000;
  if (pucha) integer[0]=pucha;
  else integer[0]=' ';
  pucha = 48+ num / 1000;
  num = num % 1000;
  if (pucha) integer[1]=pucha;
  else integer[1]=' ';
  pucha = 48+ num / 100;
  num = num % 100;
  if (pucha) integer[2]=pucha;
  else integer[2]=' ';
  pucha = 48+ num / 10;
  num = num % 10;
  if (pucha) integer[3]=pucha;
  else integer[3]=' ';
  pucha = 48+ num;
  num = num % 1;
  if (pucha) integer[4]=pucha;
  else integer[4]=' '; 
 }
 
void main(void)
{
 #asm("sei")
 USART_Init(MYUBRR);
 init();
 //LcdInit();
 fl_12=3;
while (1)
      {
       // Place your code here
       if (fl_12==3) 
        {
        putsf("3333");
         discharge_on; //
         delay_ms (100);
         discharge_off; //!
         delay_ms(10);
       
         charge_on; //  1.2V
         TCCR1B=0x00;
         TCNT1=0;
         TCCR1B=1;
         fl_12=2;
        };
       while(ACSR.ACO) {};
       if (fl_12 == 5)
        {
          //PORTD|=(1<<PD0);
          putsf("2222");
 //PORTD&=(0<<PD0);
         charge_off;
         TCCR1B=0;
         ticks=TCNT1;
         fl_12=3;
         itoa(ticks, str_buf);
         puts(str_buf);
         putsf("\n\r");
         /*LcdInt(ticks);
         LcdGotoXY(1,1);
         LcdStr(FONT_1X, integer);*/
         //LcdLine(0,20,84,48, PIXEL_ON);
         //LcdLine(0,48,84,20, PIXEL_ON);
         //#asm("sei")

         //LcdUpdate(); 
        }; 
      };
}