/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 01.12.2008
Author  : 
Company : 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 14,745600 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <m8_128.h> 
#include <stdio.h>
#include <stdlib.h>
#include <delay.h>
#define FOSC 14745600// Clock Speed
#define BAUD 57600
#define MYUBRR FOSC/16/BAUD-1
#define ADC_VREF_TYPE 0x00

char fl_12, fl_leak;
unsigned int count, capt;
unsigned int ticks;

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here
 putsf("___!!!OVERFLOW!!!___");
}

unsigned int read_adc(unsigned char adc_input)
 {
  ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
  // Delay needed for the stabilization of the ADC input voltage
  delay_us(10);
  // Start the AD conversion
  ADCSRA|=0x40;
  // Wait for the AD conversion to complete
  while ((ADCSRA & 0x10)==0);
  ADCSRA|=0x10;
  return ADCW;
 }

void init(void)
 {
  PORTB=0x00;
  DDRB=0x03;

  TCCR1A=0x00;
         
  TCNT1H=0x00;
  TCNT1L=0x00;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x00;
  OCR1BH=0x00;
  OCR1BL=0x00;
  TIMSK=0x04;
  
  ADMUX=ADC_VREF_TYPE & 0xff;
  ADCSRA=0x87;
 }

void USART_Init (unsigned int ubrr)
 {
  UBRRH=(unsigned char)(ubrr>>8);
  UBRRL=(unsigned char) ubrr;
  UCSRB=(1<<TXEN);
  UCSRC=(1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
 }


void main(void)
{
 int adc_val, leak_delay;
 float k1,k2,k3,
 unsigned int cap;
 char *buf;
 #asm("sei")
 init();
 USART_Init(MYUBRR); 
 while (1)
      {
       // Place your code here
       PORTB.1 = 1; //
       delay_ms (10);
       PORTB.1 = 0; //!
       
       TCNT1H=0x00;
       TCNT1L=0x00;
       TCCR1B=0x02;
       PORTB.0 = 1; //  1.2V
       while (capt<983) 
        {
         capt=read_adc(0);
         //printf("----%i\n\r",capt);
         delay_ms(20);  
        };
       TCCR1B=0;
       PORTB.0=0;
       ticks=ICR1;
       itoa(ticks, buf);
       puts(buf);
       putsf("\n\r");
       //printf("Ticks=%i",ticks);
       //printf(" capt=%i\n\r",capt);
       capt=0;
       PORTB.1 = 1; //
       delay_ms (20);
       PORTB.1 = 0; //!
       //timer_count=0;
       //leak_delay = 10;//   
       //delay_ms (leak_delay);
       /*if (adc_val=1023) fl_leak = 1;
       if (!fl_leak)
        {
         count = 3; // 
         PORTB.0 = 1;
         while (!fl_12) {};
         fl_12 = 0;
         while (count)
          {
           count--;
           PORTB.1 = 1;
           delay_us (10);// 
           PORTB.1 = 0;
          }
         adc_val=adc_data[0];
         //    ESR
         printf("adc_val=%i\n\r",adc_val);
        } 
       else
        printf("LEAK!!!");*/
      };
}
